/***************************************************
 * 작성자 : 이종우
 * 작성일 : 2014.09.12
 * 수정일 : 2014.10.15
 * 설 명 : index page 에서의 key event 처리 구현
***************************************************/

var GCSC_INFO = "lgtv_15_userguide_gcsc_info";

$(document).ready(function() {
	initRecentlyItems();
	$('.help-guide').on('keydown', function(e) {
		if (e.keyCode == 27) {
			clickUserGuidePageHide();
		}
	});
});

//modify main user guide page show/hide process, lee_jongwoo, 20140905 
function clickUserGuidePageShow(){
	$(".help-guide").attr('tabindex', '0').show().focus();
	$('.help-guide #helpclose').focus();
	window.localStorage.setItem("guideOn", 1);
}

function clickUserGuidePageHide(){
	$(".help-guide").removeAttr('tabindex').hide();
	window.localStorage.setItem("guideOn", 0);
}

//guide show/hide process when init main page, lee_jongwoo, 20140905
function isGuide() {

	var bGuide = window.localStorage.getItem("guideOn");
	//console.log("bGuide : " + bGuide);
	if(bGuide == null) {
		clickUserGuidePageShow();
	}
	else {
		clickUserGuidePageHide();	
	}
}

// add, jongwoo_lee, 20141107, init recently item
function initRecentlyItems() {
	var path = location.pathname;
	var pathArray = path.split("/");
	var div_zip = pathArray[pathArray.length-3];
	var div_country = pathArray[pathArray.length-2];
	
	var currentGCSCInfo = div_zip + "/" + div_country;
	var savedGCSCInfo = window.localStorage.getItem(GCSC_INFO);
	
//	console.log("saved : " + savedGCSCInfo + " / current : " +  currentGCSCInfo);
	
	if(savedGCSCInfo == null) {
		window.localStorage.setItem(GCSC_INFO, currentGCSCInfo);
	}
	else if(savedGCSCInfo != currentGCSCInfo) {
		window.localStorage.clear();
		window.localStorage.setItem(GCSC_INFO, currentGCSCInfo);
	}
}
