/***************************************************
 * 작성자 : 이종우
 * 작성일 : 2014.09.11
 * 수정일 : 2014.09.16
 * 설 명 : 최근 항목 page 에서의 key event 처리 기능 구현
 ***************************************************/
/*******************************************************************************************************************************************************************************************************
 * 2차작성자 : 허남윤 작성일 : 2014.09.17 수정일 : 2014.09.17 설 명 : 검색결과 항목 page 에서의 key event 처리 기능 구현
 ******************************************************************************************************************************************************************************************************/

//key code
//var KEY_BACK = "65";
var KEY_BACK_TV = BackKey;
var KEY_ENTER = enterKey;
var KEY_LEFT = leftKey;
var KEY_UP = upKey;
var KEY_RIGHT = rightKey;
var KEY_DOWN = downKey;

//item index
var INDEX_SEARCH = 0;
var INDEX_FIRST_ITEM = 1;
var INDEX_LAST_ITEM = 10;

var itemIndex = INDEX_SEARCH;
var bBack = false;
var bmoreFocus = false;
var bsearchbarFocus = false;
var keydowncheck = -1;
var mouseMoveCheck = false;
var backeventcheck = true;
var scrollStartFlag = false;


var itemFocus = false;
var scrollFocus = false;

var ITEM_HEIGHT		= 60;
var SCROLL_INTERVAL_TIME	= 50;

var isScrollDirection	= true;	 // true : up / false : down
var isScrollKeyDown		= false; // down : true / up : false

var intervalId;

//웹 문서 읽은 후 DOM 생성
$(document).ready(function() {
	// 페이지 로딩
	$(window).load(function() {
		getSearch();
		INDEX_LAST_ITEM = $(".list-2 ul li:visible").length;
		//console.log("INDEX_LAST_ITEM " + INDEX_LAST_ITEM);
		//console.log(".list-2 ul li " + $(".list-2 ul li").length);
		if (INDEX_LAST_ITEM > 0) {
			$(".list-2 ul li:nth-child(1)").children('a').focus();
			itemIndex = 1;
			bBack = false;
			bmoreFocus = false;
			bsearchbarFocus = false;
			itemFocus = false;
			scrollFocus = false;
		} else {
			bBack = true;
			$(".btn-back").focus();
		}

		$(".search").mouseover(function() {
			//if(keydowncheck < 0){
			if(searchCloseFlag == true){
				bBack = false;
				bmoreFocus = false;
				bsearchbarFocus = true;
				itemIndex = 0;
				$(".search").focus();
				itemFocus = false;
				scrollFocus = false;
			}
			//keydowncheck = 1;
			//}else{
			//	keydowncheck = -1;
			//}
		}).mouseout(function() {
			//if(keydowncheck == 1)
			{
				//$(this).blur();
				if(searchCloseFlag == true){
					$(".result-wrap").focus();
				}
			}
		}).on("keydown", function(e) {
			e.stopPropagation();
			//e.preventDefault();
			if (e.keyCode == KEY_LEFT) {
				// console.log("search key left");
				leftKeyEvent();
			}
			if (e.keyCode == KEY_UP) {
				// console.log("search key up");
				e.preventDefault();
				upKeyEvent();
			}
			if (e.keyCode == KEY_RIGHT) {
				// console.log("search key right");
				rightKeyEvent();
			}
			if (e.keyCode == KEY_DOWN) {
				// console.log("search key down");
				e.preventDefault();
				downKeyEvent();

			}
			if (e.keyCode == KEY_ENTER) {
				// console.log("search key enter");
				enterKeyEvent();
			}
			// if(e.keyCode == KEY_BACK || e.keyCode == KEY_BACK_TV) {
			if (e.keyCode == KEY_BACK_TV) {
				// console.log("search key back");
				backKeyEvent();
			}


		});

		$(".btn-back").mouseover(function() {
			//if(keydowncheck < 0){
			if(searchCloseFlag == true){
				bBack = true;
				bsearchbarFocus = false;
				$(".btn-back").focus();
				itemFocus = false;
				scrollFocus = false;
			}
			//keydowncheck = 1;
			//}else{
			//	keydowncheck = -1;
			//}
		}).mouseout(function() {
			//if(keydowncheck == 1)
			{
				//$(this).blur();
				if(searchCloseFlag == true){
					$(".result-wrap").focus();
				}
			}
		}).on("keydown", function(e) {
			e.stopPropagation();
			if (e.keyCode == KEY_LEFT) {
				// console.log("btn-back key left");
				leftKeyEvent();
			}
			if (e.keyCode == KEY_UP) {
				// console.log("back-back key up");
				upKeyEvent();
			}
			if (e.keyCode == KEY_RIGHT) {
				// console.log("back-back key right");
				rightKeyEvent();
			}
			if (e.keyCode == KEY_DOWN) {
				// console.log("back-back key down");
				e.preventDefault();
				downKeyEvent();
			}
			if (e.keyCode == KEY_ENTER) {
				// console.log("back-back key enter");
				enterKeyEvent();
			}
			if (e.keyCode == KEY_BACK_TV) {
				// console.log("back-back key back");
				backKeyEvent();
			}

			// e.preventDefault();
		});






		$(".list-2 ul li ").hover(function(e) {
			//if(keydowncheck<0){
			if(searchCloseFlag == true && scrollStartFlag == false){
				$(".result-wrap").focus();
			}
			//}
		});

		//$(".list-2 ul li a ").hover(function(e) {
		$(".list-2 ul li a ").mousemove(function(e) {
			// index() 로 나오는 index 는 0 부터 시작
			// nth-child 는 1 부터 시작
			//console.log("aaaaa");
			if(searchCloseFlag == true){
				//if(keydowncheck<0){
				if(scrollStartFlag == false){
					bBack = false;
					bmoreFocus = false;
					bsearchbarFocus = false;
					var thisItem = $(this);
					//itemIndex = $(".list-2 ul li a").index($(this)) + 1;
					itemIndex = $(".list-2 ul li a").index(thisItem) + 1;
					$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
					itemFocus = false;
					scrollFocus = false;
					//keydowncheck = 1;
				//}else{
					//keydowncheck = -1;
				}
			}
		}).mouseout(function(e) {
			//if(keydowncheck == 1)
			{
				//$(this).blur();
				// e.stopPropagation();
				//$(".result-wrap").focus();
			}
		}).on("keydown", function(e) {
			//console.log("1111111111");
			e.stopPropagation();
			//e.preventDefault();
			if (e.keyCode == KEY_LEFT) {
				// console.log("ul li key left");
				leftKeyEvent();
			}
			if (e.keyCode == KEY_UP) {
				// console.log("ul li key up");
				e.preventDefault();
				upKeyEvent();
			}
			if (e.keyCode == KEY_RIGHT) {
				// console.log("ul li key right");
				rightKeyEvent();
			}
			if (e.keyCode == KEY_DOWN) {
				// console.log("ul li key down");
				e.preventDefault();
				downKeyEvent();
			}
			if (e.keyCode == KEY_ENTER) {
				// console.log("ul li key enter");
				enterKeyEvent();
			}
			if (e.keyCode == KEY_BACK_TV) {
				// console.log("ul li key back");
				backKeyEvent();
			}

			// e.preventDefault();
		});

		$(".list-2 .more a ").mouseover(function() {
			//if(keydowncheck <0){
			// index() 로 나오는 index 는 0 부터 시작
			// nth-child 는 1 부터 시작
			if(searchCloseFlag == true && scrollStartFlag == false){
				bBack = false;
				bmoreFocus = true;
				bsearchbarFocus = false;
				// itemIndex = $(".list-2 ul li a").index($(this)) + 1;
				$(".list-2 .more a").focus();
			}
			//keydowncheck = 1;			
			//}
			//else{
			//	keydowncheck = -1;
			//}
		}).mouseout(function() {
			//if(keydowncheck == 1)
			{
				//$(this).blur();
				if(searchCloseFlag == true){
					$(".result-wrap").focus();
				}
			}
		}).on("keydown", function(e) {
			e.stopPropagation();
			if (e.keyCode == KEY_LEFT) {
				// console.log("ul li key left");
				leftKeyEvent();
			}
			if (e.keyCode == KEY_UP) {
				// console.log("ul li key up");
				upKeyEvent();
			}
			if (e.keyCode == KEY_RIGHT) {
				// console.log("ul li key right");
				// rightKeyEvent();
			}
			if (e.keyCode == KEY_DOWN) {
				// console.log("ul li key down");
				// downKeyEvent();
			}
			if (e.keyCode == KEY_ENTER) {
				// console.log("ul li key enter");
				//enterKeyEvent();
				keydowncheck = 0;

			}
			if (e.keyCode == KEY_BACK_TV) {
				// console.log("ul li key back");
				backKeyEvent();
			}

			// e.preventDefault();
		});


		//$('.result-wrap').focus(function() {
			//console.log("wrap focus");
			$('.result-wrap').on("keydown", function(e) {
				//console.log("wrap keydown");
				e.stopPropagation();
				if (e.keyCode == KEY_BACK_TV) {
					// if (e.keyCode == BackKey) {
					//console.log("back key");
					// history.back();
					backKeyEvent();
				} else if (bBack == true) {
					$(".btn-back").focus();
				} else if (bsearchbarFocus == true) {
					$(".search").focus();
				} else {
					if (bmoreFocus == true) {
						$(".list-2 .more a").focus();
					} else if (itemIndex == 0) {
						$(".search").focus();
					} else {
						$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
					}
				}
			});
		//});


		/*****************************************************************************/
		// up
		$(".arrow-up")
		.mouseover(function() {
			if(searchCloseFlag == true && scrollStartFlag == false) {
				backFocus = false;
				itemFocus = false;
				scrollFocus = true;
				isScrollDirection = true;
				isScrollButtonDown = false;
				$(".arrow-up").focus();
			}
		})
		.mouseout(function() {
			if(searchCloseFlag == true && scrollStartFlag == false){
				$('.result-wrap').focus();
			}
		})
		.mousedown(function(){
			intervalId = setInterval(scrollUpEvent, SCROLL_INTERVAL_TIME);
		})
		.mouseup(function(){
			clearInterval(intervalId);
		})
		.on("keydown", function(e) {
			e.stopPropagation();
			isKeyDown = 1;
			if(e.keyCode == leftKey) {
				leftKeyEvent();
			}
//			if(e.keyCode == upKey) {
//				upKeyEvent(e);
//			}
//			if(e.keyCode == rightKey) {
//				rightKeyEvent();
//			}
			if(e.keyCode == downKey) {
				downKeyEvent(e);
			}
//			if(e.keyCode == enterKey) {
//				if(isScrollKeyDown == false) { 
//					isScrollKeyDown = true;
//					enterKeyEvnet();
//				}
//			}
			if(e.keyCode == BackKey) {
				backKeyEvent();
			}
		});
//		.on("keyup", function(e) {
//			isKeyDown = 1;
//			if(e.keyCode == KEY_ENTER) {
//				isScrollKeyDown = false;
//				clearInterval(intervalId);
//			}
//		});
		
		//down
		$(".arrow-down")
		.mouseover(function() {
			if(searchCloseFlag == true && scrollStartFlag == false){
				backFocus = false;
				itemFocus = false;
				scrollFocus = true;
				isScrollDirection = false;
				isScrollButtonDown = false;
				$(".arrow-down").focus();
			}
		})
		.mouseout(function() {
			if(searchCloseFlag == true && scrollStartFlag == false){
				$('.result-wrap').focus();
			}
		})
		.mousedown(function(){
			intervalId = setInterval(scrollDownEvent, SCROLL_INTERVAL_TIME);
		})
		.mouseup(function(){
			clearInterval(intervalId);
		})
		.on("keydown", function(e) {
			e.stopPropagation();
			isKeyDown = 1;
			if(e.keyCode == leftKey) {
				leftKeyEvent();
			}
			if(e.keyCode == upKey) {
				upKeyEvent(e);
			}
//			if(e.keyCode == rightKey) {
//				rightKeyEvent();
//			}
//			if(e.keyCode == downKey) {
//				downKeyEvent(e);
//			}
//			if(e.keyCode == enterKey) {
//				if(isScrollKeyDown == false) {
//					isScrollKeyDown = true;
//					enterKeyEvnet();
//				}
//			}
			if(e.keyCode == BackKey) {
				backKeyEvent();
			}
		});
//		.on("keyup", function(e) {
//			isKeyDown = 1;
//			if(e.keyCode == KEY_ENTER) {
//				isScrollKeyDown = false;
//				clearInterval(intervalId);
//			}
//		});
		/*****************************************************************************/

//		$(".list-2 ").scroll( function() {
//		console.log("aaaaaaaaaaaaaaaaaaaaaaaaaa");
//		var elem = $(".list-2 ");
//		console.log($(".list-2").scrollTop());
////		if ( elem[0].scrollHeight - elem.scrollTop() == elem.outerHeight())
////		{

////		$(document).scrollTop();
////		alert("End of Yellow");
////		}
//		});


$(".list-2").scroll(function() {
    clearTimeout($.data(this, 'scrollTimer'));
    $.data(this, 'scrollTimer', setTimeout(function() {
        // do something
		scrollStartFlag = false;
        //console.log("Haven't scrolled in 250ms!");
    }, 250));
	//console.log("scroll start");
	scrollStartFlag = true;
});


	});
});

function leftKeyEvent() {
	if($(".arrow-up").is(":focus") || $(".arrow-down").is(":focus")){
		$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
	}else{
		bBack = true;
		$(".btn-back").focus();
		// console.log("item index : " + itemIndex);
		keydowncheck = 0;
	}
}

function rightKeyEvent() {
	if($(".list-2 ul li a").is(":focus")){
		itemFocus = true;
		scrollFocus = true;
		if(isScrollDirection){
			$(".arrow-up").focus();
		}else{
			$(".arrow-down").focus();
		}

	}else{
		itemFocus = false;
		scrollFocus = false;
		bBack = false;
		$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
		// console.log("item index : " + itemIndex);
	}
	keydowncheck = 0;
}

function upKeyEvent() {
	if($(".arrow-down").is(":focus")){
		itemFocus = true;
		scrollFocus = true;
		isScrollDirection = true;
		$(".arrow-up").focus();

	}else if (bmoreFocus == true) {
		bBack = false;
		bmoreFocus = false;
		// $(".list-2 ul li:nth-child(" + INDEX_LAST_ITEM + ")").get(0).scrollIntoView(false);
		$(".list-2 ul li:nth-child(" + INDEX_LAST_ITEM + ")").children('a').focus();
	} else {
		bmoreFocus = false;
		if (itemIndex >= INDEX_FIRST_ITEM) {
			if (bBack == false) {
				itemIndex--;
			}
		}
		bBack = false;
		if (itemIndex == INDEX_SEARCH) {
			$(".search").focus();
		} else {

			$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
		}
	}
	keydowncheck = 0;
	// console.log("item index : " + itemIndex);
}

function downKeyEvent() {

	if($(".arrow-up").is(":focus")){
		itemFocus = true;
		scrollFocus = true;
		isScrollDirection = false;
		$(".arrow-down").focus();

	}else if (itemIndex >= INDEX_LAST_ITEM) {
		itemIndex = INDEX_LAST_ITEM;
		//console.log("bmoreFocus " + bmoreFocus);
		if (bBack == true && bmoreFocus == false) {
			bBack = false;

			$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
		} else {
			bBack = false;
			bmoreFocus = true;
			$(".list-2 .more a").focus();
		}
	} else if (itemIndex < INDEX_LAST_ITEM) {
		if (bBack == true) {
			bBack = false;
			if (itemIndex <= 0)
				itemIndex = 1;
		} else {

			itemIndex++;
		}

		$(".list-2 ul li:nth-child(" + itemIndex + ")").children('a').focus();
	}
	keydowncheck = 0;
	//console.log("item index : " + itemIndex);
	//console.log("INDEX_LAST_ITEM : " + INDEX_LAST_ITEM);
}

function enterKeyEvent() {
	// location.href= $(this).attr("href");
}

function backKeyEvent() {
	if(backeventcheck){
		backeventcheck = false;
		bBack = false;
		//console.log("backkey;;;;;;");

		var prevPageUrl = getSearchLastPrevPage();

		var searchPrevIndexval = window.localStorage.getItem(String("searchPrevIndex"));
		window.localStorage.removeItem(String("searchPrevPage" + searchPrevIndexval));
		searchPrevIndexval--;
		window.localStorage.setItem(String("searchPrevIndex"), searchPrevIndexval);

		window.location.href = prevPageUrl;
		//window.location.href = "./index.html"
//		var prevPageUrl = window.localStorage.getItem("result_prevpage");
//		window.location.href = prevPageUrl;
		// window.history.back();
		// $('.container > *').show();
		// $('.container').animate({top:'-1080px'}, 500);
	}
}

function scrollUpEvent() {
	$(".list-2").scrollTop($(".list-2").scrollTop() - ITEM_HEIGHT);
}

function scrollDownEvent() {
	$(".list-2").scrollTop($(".list-2").scrollTop() + ITEM_HEIGHT);
}
